// © 2023, CGVR (https://cgvr.informatik.uni-bremen.de/),
// Author: Andre Mühlenbrock (muehlenb@uni-bremen.de)

#pragma once

#include <vector>
#include <memory>

#include "src/scene/Surface.h"

/**
 * A surface that consists of multiple surfaces (inherits from Surface).
 */
class SurfaceList : public Surface {
    std::vector<std::shared_ptr<Surface>> surfaces;

public:
    /**
     * Adds a surface to this surface list.
     */
    void addSurface(std::shared_ptr<Surface> surface);

    /**
     * See documentation in the parent Surface class.
     */
    virtual Intersection intersect(Ray ray, float t0, float t1) override;
};
