// © 2023, CGVR (https://cgvr.informatik.uni-bremen.de/),
// Author: Andre Mühlenbrock (muehlenb@uni-bremen.de)

#pragma once

#include "src/math/Mat4f.h"
#include "src/scene/Surface.h"

class Quadric : public Surface {
    Mat4f Q;

public:
    Quadric(Mat4f Q, Shader pShader);

    virtual Intersection intersect(Ray ray, float tStart, float tEnd) override;

    float F(Vec4f X);
};
